<?php

namespace Drupal\acquia_contenthub\EventSubscriber\CDFAttributes;

use Acquia\ContentHubClient\Attribute\CDFDataAttribute;
use Drupal\acquia_contenthub\AcquiaContentHubEvents;
use Drupal\acquia_contenthub\Event\CDFAttributesEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

/**
 * Calculates a hash value of the entity and stores it as an attribute.
 */
class HashCDFAttribute  implements EventSubscriberInterface {

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    $events[AcquiaContentHubEvents::POPULATE_CDF_ATTRIBUTES][] = ['onPopulateAttributes', 100];
    return $events;
  }

  public function onPopulateAttributes(CDFAttributesEvent $event) {
    $entity = $event->getEntity();
    $cdf = $event->getCDF();
    $cdf->addAttribute('hash', CDFDataAttribute::TYPE_STRING, sha1(json_encode($entity->toArray())), 'und');
  }

}
